; site : http://the.sunnyspot.org/gimp/scripts.html
;
; But : Crer une nouvelle image par duplication en paramtrant les lignes et les colonnes
; Accs sur l'image par Image > Replicator
;
; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
;
; Replicator script --- Clone an image into a bigger one filled with the
;                       original.
; Copyright (C) 1997-98 Marco Lamberto
; lm@geocities.com
; http://www.geocities.com/Tokyo/1474/gimp/
;
; $Revision: 1.3 $
; version novembre 2010 par samj
; ajouts : imposer les dimensions, rendre raccordable
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

; main function

(define (script-fu-replicator image drawable rows columns forcing_image_size forcing_width forcing_height raccord)

	; vrification lignes, colonnes et correction
	(if (< rows 1) (set! rows 1))
	(if (< columns 1) (set! columns 1))


	(let*
		(
			(w (car (gimp-drawable-width drawable)))
			(h (car (gimp-drawable-height drawable)))
			(w2 (* w columns))
			(h2 (* h rows))
			(image2 (car (gimp-image-new w2 h2 0)))
			(layer2 (car (gimp-layer-new image2 w2 h2 1 "layer 1" 100 0)))
			(i 1)
			(j 1)
			(drawable2 1)
			(fs 1)
			(verif_taille (* w2 h2))
			(message_taille "Warning Replicator : image > 10000*10000")
		)

		; vrification des dimensions pour ne pas obtenir de trop grosses images < 10000*10000
		(if
			(> verif_taille (* 10000 10000))

				(begin
					(gimp-message message_taille)
					(set! rows 1)
					(set! columns 1)
					(set! forcing_image_size TRUE)
					(set! forcing_width 800)
					(set! forcing_height 600)
					(set! image2 (car (gimp-image-new forcing_width forcing_height 0)))
					(set! layer2 (car (gimp-layer-new image2 forcing_width forcing_height 1 "layer 1" 100 0)))
				)
		)

		(gimp-image-add-layer image2 layer2 0)

		(set! drawable2 (car (gimp-image-get-active-drawable image2)))

		; moyen pour "effacer" ou mettre une image "vide" dans le presse-papiers
		(gimp-edit-copy drawable2)

		(set! fs (car (gimp-edit-paste drawable2 FALSE)))

		(gimp-image-undo-group-start image)

		(gimp-image-undo-group-start image2)

		(gimp-selection-none image)

		(gimp-selection-all image)

		(gimp-edit-copy-visible image)
		;(gimp-edit-copy drawable)

		(gimp-selection-none image)

		(set! i w2)

		(while
			(> i 0)

			(set! i (- i w))

			(set! j h2)

			(while
				(> j 0)

				(set! j (- j h))

				(gimp-rect-select image2 i j w h ADD FALSE 0)

				(set! fs (car (gimp-edit-paste drawable2 FALSE)))

				(gimp-selection-none image2)

			)
		)


		(gimp-floating-sel-anchor fs)

		; faut-il redimensionner ?
		(if
			(= forcing_image_size TRUE)

				(begin

					; vrification largeur et hauteur
					(if (< forcing_width 1) (set! forcing_width 800))
					(if (< forcing_height 1) (set! forcing_height 600))

					; redimensionner image
					(gimp-image-resize image2 forcing_width forcing_height 0 0)
					(gimp-layer-scale-full layer2 forcing_width forcing_height FALSE 2)
					(gimp-layer-resize layer2 forcing_width forcing_height 0 0)
				)
		)

		; faut-il rendre raccordable ?
		(if
			(= raccord TRUE)

				(begin
					;(gimp-message "raccordable")
					(plug-in-make-seamless 0 image2 layer2)
				)
		)

		;message alerte sur l'image
		(if (> verif_taille (* 10000 10000))(gimp-text-fontname image2 layer2 10 400 message_taille 30 TRUE 36 0 "Sans"))

		(gimp-display-new image2)

		(gimp-image-undo-group-end image2)

		(gimp-image-undo-group-end image)

		(gimp-displays-flush)

	)

)

; Register!

(script-fu-register "script-fu-replicator"
	"<Image>/Image/Replicator"
	"Clone an image into a bigger one filled with the original. Nouvelle image par duplication en paramtrant les lignes et colonnes"
	"Marco Lamberto <lm@geocities.com>"
	"Marco Lamberto"
	"01 Aug 1997 - 30 Aug 1998 - 29 Nov 2010"
	"RGB*, GRAY*"
	SF-IMAGE "Image" 0
	SF-DRAWABLE "Drawable" 0
	SF-VALUE "Rows / Lignes" "2"
	SF-VALUE "Columns / Colonnes" "2"
	SF-TOGGLE "Forcing image size" FALSE
	SF-VALUE "Forcing width" "800"
	SF-VALUE "Forcing height" "600"
	SF-TOGGLE "Tileable" FALSE
)

; Fin du script